//The code is at PoC level, it was developed for demonstration purposes.
//The code is released under GPL (http://www.gnu.org/licenses/gpl.html), by Laszlo Toth.
//Use the code at your own responsibility.
//http://soonerorlater.hu/index.khtml?article_id=516

#include <string.h>
#include <openssl/evp.h> 
#include <openssl/sha.h>
#include <openssl/md5.h>
#include "getopt.h"

int HexStringtoBinArray(unsigned char* str, unsigned char* array);
int BinArraytoHexString(char* str, unsigned char* array, int len);

static struct option long_options[] ={
	{"file", required_argument, 0, 'f'},
	{"key", required_argument, 0, 'k'},
	{"ofile", required_argument, 0, 'o'},
	{"column", required_argument, 0, 'c'},
	{"encalg", required_argument, 0, 'e'},
	{"intalg", required_argument, 0, 'a'},
	{"iv", no_argument, 0, 'i'},
	{0,0,0,0}
};

int main(int argc, char* argv[])
{

	char* ifile=NULL;
	FILE* ifh;
	char* ofile=NULL;
	FILE* ofh;
	char* testkey=NULL;
	unsigned char bintestencdata[10000];
	unsigned char bintestkey[100];
	unsigned char bintestiv[100];
	int outlen;
	int block_size=8192;
	unsigned char* decrypted_data;
	char* hex_decrypted_data;
	EVP_CIPHER* cipher;
	//Which column from the rorablock output
	int column=0;
	//Encryption algorithm from the enc$ table
	int encalg=0;
	//Is there mac according the enc$ table
	int intalg=1;
	//If there is iv (or salt), it is at the end of the encrypted value. You
	//can see from the log file or it can be chekced in the col$ table.
	int iv=1;
	//If there is salt or mac, we should calculate the right value
	int data_len=0;
	EVP_CIPHER_CTX ctx;

	int option_index = 0;
	int opt = getopt_long (argc, argv, "f:k:o:c:e:i:",
		long_options, &option_index);

	while(opt != -1){
		switch(opt){
		case 'f':
			ifile=optarg;
			break;
		case 'k':
			testkey=optarg;
			break;
		case 'o':
			ofile=optarg;
			break;
		case 'c':
			column=atoi(optarg);
			break;
		case 'e':
			encalg=atoi(optarg);
			break;
		case 'a':
			intalg=atoi(optarg);
			break;
		case 'i':
			iv=1;
			break;
		}
		opt = getopt_long (argc, argv, "f:k:o:c:e:i", long_options, &option_index);
	}

	if(!testkey){
		printf("Key parameter (-k) is missing!\n");
		return -1;
	}

	int keylen=strlen(testkey);
	switch(keylen){
	case 32:
		cipher=(EVP_CIPHER*)EVP_aes_128_cbc();
		break;
	case 42:
		cipher=(EVP_CIPHER*)EVP_des_ede3_cbc();
		break;
	case 48:
		cipher=(EVP_CIPHER*)EVP_aes_192_cbc();
		break;
	case 64:
		cipher=(EVP_CIPHER*)EVP_aes_256_cbc();
		break;
	default:
		printf("Invalid key length!\nThe valid length are: 128, 168, 192, 256 bit!\n");
		return -1;
	}

	HexStringtoBinArray((unsigned char*)testkey,bintestkey);

	if(!ifile){
		printf("Input file (-f) parameter is missing!\n");
		return -1;
	}
	ifh=fopen(ifile, "rb");
	if(!ifh){
		printf("Could not open the input file: %s!\n", ifile);
		return -1;
	}

	if(ofile){
		ofh=fopen(ofile, "wb");
		if(!ifh){
			printf("Could not open the output file: %s!\n", ofile);
			return -1;
		}
	}else{
		printf("Output file parameter (-o) is missing!\n");
		return -1;
	}

	char line[10000];
	int rindx=-1;
	while(!feof(ifh)){
		fgets(line, 10000, ifh);
		if(line[0]=='-'){
			rindx++;
			continue;
		}else if(line[0]==0xA || line[0]==0xD || line[0]=='C'){
			continue;
		}

		for(int i=1; i < column; i++){
			fgets(line,10000, ifh);
		}
		char tmp[10000];
		int tmp_len=0;
		memset(tmp,0,sizeof(tmp));

		for(int i=0; line[i]!=':'; i++){
			tmp[i]=line[i];
		}
		data_len=atoi(tmp);
		decrypted_data=(unsigned char*)calloc(data_len,1);
		tmp_len=strlen(tmp);
		int j=0;
		for(unsigned int i=0; i<strlen(line)-tmp_len+1;i++){
			if(line[tmp_len+1+i]!=0x20 && line[tmp_len+1+i]!=0xD && line[tmp_len+1+i]!=0xA){
				tmp[j++]=line[tmp_len+1+i];
			}
		}

		HexStringtoBinArray((unsigned char*)tmp, bintestencdata);
		if(iv){
			memmove(bintestiv, bintestencdata+data_len-16,16);
			data_len-=16;
		}else{
			memset(bintestiv,0,16);
		}

		if(intalg==1){
			data_len-=20;
		}

		int final_outlen=0;
		EVP_CIPHER_CTX_init(&ctx);
		EVP_DecryptInit_ex(&ctx, cipher, NULL, bintestkey, bintestiv);
		EVP_DecryptUpdate(&ctx, decrypted_data, &outlen, bintestencdata, data_len);
		final_outlen=outlen;
		EVP_DecryptFinal(&ctx, decrypted_data+outlen, &outlen);
		final_outlen+=outlen;
		EVP_CIPHER_CTX_cleanup(&ctx);
		hex_decrypted_data=(char*)calloc(final_outlen*2+3,1);
		BinArraytoHexString(hex_decrypted_data, decrypted_data, final_outlen);
		fprintf(ofh,"%s\n",hex_decrypted_data);
	}

	fclose(ifh);
	fclose(ofh);

	return 0;
}

int HexStringtoBinArray(unsigned char* str, unsigned char* array){

	int alen=strlen((char*)str)/2;
	unsigned char t[2];
	unsigned int hexc;
	int j=0;

	for(unsigned int i=0;i<strlen((char*)str);i=i+2){
		t[0]=str[i];
		t[1]=str[i+1];
		hexc = t[0]-48;
		if (hexc > 9) hexc-=7;
		array[j]=hexc*16;
		hexc = t[1]-48;
		if (hexc > 9) hexc-=7;
		array[j]+=hexc;
		j++;
	}
	return j;
}

int BinArraytoHexString(char* str, unsigned char* array, int len){

	char t[3];
	int i=0;

	for(i=0; i< len; i++){
		sprintf(t,"%02X", array[i]);
		strncat(str, t, 2);
	}

	return i*2;
}