//The code is at PoC level, it was developed for demonstration purposes.
//The code is released under GPL (http://www.gnu.org/licenses/gpl.html), by Laszlo Toth.
//Use the code at your own responsibility.
//http://soonerorlater.hu/index.khtml?article_id=516

#include <openssl/evp.h>
#include <string.h>
#include "getopt.h"
#include <openssl/bio.h>
#include <openssl/buffer.h>

char *unbase64(unsigned char *input, int length);
int HexStringtoBinArray(unsigned char* str, unsigned char* array);
int BinArraytoHexString(char* str, unsigned char* array, int len);

static struct option long_options[] ={
	{"file", required_argument, 0, 'f'},
	{"mkey", required_argument, 0, 'k'},
	{"tkey", required_argument, 0, 't'},
	{0,0,0,0}
};

int main(int argc, char* argv[])
{
	int block_size=8192;
	EVP_CIPHER_CTX ctx;
	int outlen=0;


	char* ifile=NULL;
	FILE* ifh;
	//1 means tablekey, 2 means tablspace key
	int enctkey=1;

	unsigned char* binenctkey=NULL;
	unsigned char bindectkey[100];
	char* dectkey;

	unsigned char* binmkey=NULL;
	char* mkey=NULL;

	unsigned char binenctblspckey[100];
	unsigned char bindectblspckey[100];
	unsigned char dectblspckey[100];

	unsigned char mk_iv[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

	int option_index = 0;
	int opt = getopt_long (argc, argv, "f:k:t:",
		long_options, &option_index);

	while(opt != -1){
		switch(opt){
		case 'f':
			ifile=optarg;
			break;
		case 'k':
			mkey=optarg;
			break;
		case 't':
			enctkey=atoi(optarg);
			break;
		}
		opt = getopt_long (argc, argv, "f:k:t:", long_options, &option_index);
	}

	if(!mkey){
		printf("Mastrekey is needed from the oracle wallet! (-k)\n");
		return -1;
	}

	binmkey=(unsigned char*)calloc(strlen(mkey),1);
	HexStringtoBinArray((unsigned char*)mkey, binmkey);

	if(ifile==NULL){
		printf("Encrypted tablekey file or the tablespace file (-f) is missing. One of them is needed!\n");
		return -1;
	}else{
		ifh=fopen(ifile,"r");
		if(!ifh){
			printf("Could not open the input file: %s!\n",ifile);
		}
	}


	char line[10000];
	int rindx=0;
	int column=4;
	if(enctkey==1){
		while(!feof(ifh)){
			fgets(line, 10000, ifh);
			if(line[0]=='-'){
				rindx++;
				printf("%s",line);
				continue;
			}else if(line[0]==0xA || line[0]==0xD || line[0]=='C'){
				continue;
			}else{
				printf("%s",line);
			}

			for(int i=1; i < column-1; i++){
				fgets(line,10000, ifh);
				printf("%s", line);
			}
			printf("\n");
			fgets(line,10,ifh);
			switch(line[0]){
			case '1':
				printf("3 Key Triple DES 168 bits key\n");
				break;
			case '2':
				printf("AES 128 bits key\n");
				break;
			case '3':
				printf("AES 192 bits key\n");
				break;
			case '4':
				printf("AES 256 bits key\n");
				break;
			}

			fgets(line,10,ifh);
			switch(line[0]){
			case '1':
				printf("SHA-1\n");
				break;
			case '2':
				printf("NOMAC\n");
				break;
			}


			fgets(line,10000, ifh);
			char* tmp=unbase64((unsigned char*)line, strlen(line)-1);
			fgets(line,10000, ifh);
			int tkeylen=atoi(line);
			binenctkey=(unsigned char*)calloc(tkeylen,1);
			memmove(binenctkey,tmp+17,tkeylen/2);

			int tkey_len=0;
			EVP_CIPHER_CTX_init(&ctx);
			EVP_DecryptInit_ex(&ctx, EVP_aes_256_cbc(), NULL, binmkey, mk_iv);
			EVP_DecryptUpdate(&ctx, bindectkey, &outlen, binenctkey, tkeylen/2);
			tkey_len+=outlen;
			EVP_DecryptFinal(&ctx, bindectkey+outlen, &outlen);
			tkey_len+=outlen;
			EVP_CIPHER_CTX_cleanup(&ctx);
			dectkey=(char*)calloc(tkey_len*2+5,1);
			BinArraytoHexString(dectkey, bindectkey, tkey_len);
			printf("%s\n", dectkey);
		}
	}else{
		//read the size of the blocks
		fseek(ifh, 20, SEEK_SET);
		fread(&block_size, 4, 1, ifh);

		fseek(ifh,block_size+784, SEEK_SET);

		char key_size;
		fread(&key_size,1,1,ifh);

		fread(binenctblspckey,key_size*8, 1, ifh);
		EVP_CIPHER_CTX_init(&ctx);
		EVP_DecryptInit_ex(&ctx, EVP_aes_256_cbc(), NULL, binmkey, mk_iv);
		EVP_DecryptUpdate(&ctx, bindectblspckey, &outlen, binenctblspckey, key_size*8);
		EVP_CIPHER_CTX_cleanup(&ctx);
		memset(dectblspckey,0,100);
		BinArraytoHexString((char*)dectblspckey, bindectblspckey, key_size*8);
		printf("%s\n", dectblspckey);
	}

	return 0;
}

int HexStringtoBinArray(unsigned char* str, unsigned char* array){

	int alen=strlen((char*)str)/2;
	unsigned char t[2];
	unsigned int hexc;
	int j=0;

	for(unsigned int i=0;i<strlen((char*)str);i=i+2){
		t[0]=str[i];
		t[1]=str[i+1];
		hexc = t[0]-48;
		if (hexc > 9) hexc-=7;
		array[j]=hexc*16;
		hexc = t[1]-48;
		if (hexc > 9) hexc-=7;
		array[j]+=hexc;
		j++;
	}
	return j;
}

int BinArraytoHexString(char* str, unsigned char* array, int len){

	char t[3];
	int i=0;

	for(i=0; i< len; i++){
		sprintf(t,"%02X", array[i]);
		strncat(str, t, 2);
	}

	return i*2;
}


char *unbase64(unsigned char *input, int length)
{
	BIO *b64, *bmem;

	char *buffer = (char *)malloc(length);
	memset(buffer, 0, length);

	b64 = BIO_new(BIO_f_base64());
	bmem = BIO_new_mem_buf(input, length);
	bmem = BIO_push(b64, bmem);
	BIO_set_flags(bmem, BIO_FLAGS_BASE64_NO_NL); 

	int len=BIO_read(bmem, buffer, length);

	BIO_free_all(bmem);

	return buffer;
}