//The code is written by David Litchfiled. I modified it a bit, to make sure it workes with my examples.
//The modification was tested with very simple test cases, use at your own responsibility.

#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <string.h>
#include "rorablock.h"

FILE *fd_data_file = NULL;
unsigned int block_size = 0;
unsigned int offset = 0;
unsigned int block_number = 0;
unsigned int offset_of_data_header_structure = 0;
unsigned char data_file[260]="";
unsigned char column_template_file[260]="";
unsigned char * the_block = NULL;
unsigned int g_object_id = 0;
unsigned int g_last_offset = 0;
unsigned int g_indx = 0;
unsigned int g_row_offset = 0;
unsigned int action = 0;
unsigned int vdebug = 0;
unsigned int one_block_only = 0;
unsigned int number_of_blocks = 0;
unsigned int col_template_present = 0;
unsigned int datafile_present = 0;
unsigned int help_needed = 0;
unsigned int verbose = 0;
unsigned char sep[4]="\n";



int ProcessArguments(int argc, char *argv[])
{
	int count = 0;
	if(argc == 1)
	{
		help_needed = 1;
		return 1;
	}
	while(count < argc)
	{

		// Get the file name of the data files
		if(strcmp(argv[count],"-f")==0)
		{
			count++;
			if(count == argc)
			{
				printf("Missing data file argument\n");
				return 0;
			}
			else
			{
				strncpy(data_file,argv[count],256);
				datafile_present = 1;
			}
		}
		// Get the file name of the column template
		else if(strcmp(argv[count],"-c")==0)
		{
			count++;
			if(count == argc)
			{
				printf("Missing column template file argument\n");
				return 0;
			}
			else
			{
				strncpy(column_template_file,argv[count],256);
				col_template_present = 1;
			}
		}

		else if(strcmp(argv[count],"-h")==0)
		{
			help_needed = 1;
		}


		// Get the number of blocks
		else if(strcmp(argv[count],"-n")==0)
		{
			count++;
			if(count == argc)
			{
				printf("Missing number of blocks argument\n");
				return 0;
			}
			else
			{
				one_block_only = 0;
				number_of_blocks = atoi(argv[count]);
			}
		}


		// Get the block size
		else if(strcmp(argv[count],"-z")==0)
		{
			count++;
			if(count == argc)
			{
				printf("Missing block size argument\n");
				return 0;
			}
			else
				block_size = atoi(argv[count]);
		}
		// Get the object ID if present
		else if(strcmp(argv[count],"-o")==0)
		{
			count++;
			if(count == argc)
			{
				printf("Missing object ID argument\n");
				return 0;
			}
			else
				g_object_id = atoi(argv[count]);
		}
		// Get the block number to start from if present
		else if(strcmp(argv[count],"-b")==0)
		{
			count++;
			if(count == argc)
			{
				printf("Missing block number argument\n");
				return 0;
			}
			else
			{
				block_number = atoi(argv[count]);
				one_block_only = 1;
			}
		}

		// Get the separator

		else if(strcmp(argv[count],"-s")==0)
		{
			count++;
			if(count == argc)
			{
				printf("Missing separator argument\n");
				return 0;
			}
			else
			{
				sep[0] = argv[count][0];
			}
		}


		// Get the action
		else if(strcmp(argv[count],"-a")==0)
		{
			count++;
			if(count == argc)
			{
				printf("Missing action argument\n");
				return 0;
			}
			else
			{
				if(argv[count][0]=='A' || argv[count][0]=='a')
					action = DUMPALL;
				else if(argv[count][0]=='D' || argv[count][0]=='d')
					action = SHOWDELETED;
				else if(argv[count][0]=='O' || argv[count][0]=='o')
					action = DUMPNOTVIAOFFSETS;
				else if(argv[count][0]=='S' || argv[count][0]=='s')
					action = SHOWDELETEDNOTVIAOFFSETS;
				else if(argv[count][0]=='C' || argv[count][0]=='c')
					action = DUMPSCNS;


				else
				{
					printf("Invalid action.");
					return 0;
				}			
			}
		}
		else if(strcmp(argv[count],"-g")==0)
		{
			vdebug = 1;
		}
		else if(strcmp(argv[count],"-v")==0)
		{
			//count++;
			verbose = 1;
		}


		count ++;
	}
	return 1;

}


int main(int argc, char *argv[])
{
	int c = 0;


	if(!ProcessArguments(argc, argv))
		return 0;

	if(help_needed)
	{
		printf("%s\n",help_options);
		return 0;
	}

	if(!datafile_present)
		return printf("Need name of data file.\n");

	if(block_size == 0)
		block_size = 8192;


	while(1)
	{
		if(orablock())
		{
			printf("\n\nCompleted.\n\n");
			break;
		}
		if(one_block_only)
			break;
	
		c ++;
		block_number++;
		if(c == number_of_blocks)
			break;
	}
	
	
	return 0;
}


int orablock()
{
	unsigned char block_type = 0;
	unsigned int object_id = 0;
	unsigned short itl_slots = 0;
	unsigned int offset_of_block_header_structure = 0;
	unsigned int size_of_block_header_structure = 20;
	unsigned int offset_of_transaction_fixed_header_structure = 20;
	unsigned int size_of_transaction_fixed_header_structure = 24;
	unsigned int size_of_data_header_structure = 14;
	unsigned int size_of_itl_list_entry = 24;
	unsigned int size_of_itl_list_index = 0;
	unsigned char typ = 0;

	unsigned short number_of_rows = 0;
	unsigned short number_of_rows_from_table_directory = 0;
	unsigned freespace_offset_start = 0;
	unsigned short freespace_offset_end = 0;
	unsigned int offset_of_table_directory_structure = 0;
	unsigned int size_of_table_directory_structure = 4;
	unsigned int offset_of_row_directory = 0;
	unsigned int number_of_table_directories = 0;
	unsigned short count = 0;
	unsigned short row_offset = 0;
	unsigned int ret = 0, ttl=0;
	unsigned int hsize = 0;
	unsigned int scn = 0;
	size_t br = 0;

	int print_row=1;

	if(block_size > 16000)
		return printf("Block size too big.\n");

	fd_data_file = fopen(data_file,"rb");


	if(!fd_data_file)
		return printf("Failed to open datafile %s\n",data_file);

	offset = block_number * block_size;

	if(fseek(fd_data_file,offset,SEEK_SET)!=0)
	{
		fclose(fd_data_file);
		free(the_block);
		return printf("Failed to set pointer.\n");
	}


	the_block = (unsigned char *)malloc(block_size+1);
	if(!the_block)
		return printf("malloc failure.\n");

	memset(the_block,0,block_size+1);



	br = fread(the_block, 1,  block_size, fd_data_file);
	if(br != block_size)
	{
		if(feof(fd_data_file))
		{
			free(the_block);
			fclose(fd_data_file);
			return 2;
		}
		else
		{
			printf("Failed to read %d bytes\n",block_size);
			fclose(fd_data_file);
			free(the_block);
			return 1;
		}
	}
	fclose(fd_data_file);


	// Get the Object ID of the object inhabiting the block

	memmove(&object_id, &the_block[24], 4);

	// If we've been given an object ID to match check it
	if(g_object_id)
	{
		// discard if it's not the same
		if(g_object_id != object_id)
		{
			free(the_block);
			return 0;
		}
	}




	// Get the block type

	block_type = the_block[0];
	if(block_type > 11 && vdebug)
			printf("Unknown block type...\n");
	else
	{
		if(vdebug)
			printf("Block type: %s (%d)\n",block_types[block_type], block_type);
	}


	memmove(&typ, &the_block[20], 1);

	if(typ==1)
	{
		if(vdebug)
			printf("Type: DATA\n");
	}
	else if(typ==2)
	{
		if(vdebug)
			printf("Type: INDEX\n");
		free(the_block);
		return 0;
	}
	else
	{

		if(vdebug)
			printf("Type: Unknown: %d\n",typ);
		free(the_block);
		return 0;
	}

	if(action == DUMPSCNS)
	{
		memmove(&scn,&the_block[8],4);
		printf("Block ID: %d, Object ID: %d, SCN: %d\n",block_number,object_id,scn);
		free(the_block);
		return 0;
	}




//	if(vdebug || !g_object_id)
//		printf("\n\nBlock ID: %d\nObject ID: %d\n", block_number, object_id);


	memmove(&itl_slots, &the_block[36], 1);
	if(vdebug)
		printf("ITL Slots: %d\n", itl_slots);

	size_of_itl_list_index = itl_slots * size_of_itl_list_entry;

	offset_of_data_header_structure = size_of_itl_list_index + size_of_block_header_structure + size_of_transaction_fixed_header_structure;

	if(offset_of_data_header_structure > (block_size - size_of_data_header_structure))
	{
		free(the_block);
		return printf("Offset of data header structure is out of bounds.\n");
	}

	if(vdebug)
		printf("offset DHS: %.2X \n",offset_of_data_header_structure);


	// number of table directories
	memmove(&number_of_table_directories,&the_block[offset_of_data_header_structure+1],1);

	memmove(&number_of_table_directories,&the_block[offset_of_data_header_structure+1],1);

	if(vdebug)
		printf("Number of table directories: %d\n",number_of_table_directories);

	// Get the number of rows
	memmove(&number_of_rows,&the_block[offset_of_data_header_structure+2],2);
	if(vdebug)
		printf("Number of rows: %d\n",number_of_rows);

	// Get the start of the free space offset
	memmove(&freespace_offset_start,&the_block[offset_of_data_header_structure+6],2);
	if(vdebug)
		printf("Freespace offset start: %X\n",freespace_offset_start);

	// Get the end of the free space offset
	memmove(&freespace_offset_end,&the_block[offset_of_data_header_structure+8],2);
	if(vdebug)
		printf("Freespace offset end: %X\n",freespace_offset_end);




	offset_of_table_directory_structure = offset_of_data_header_structure + size_of_data_header_structure;
	if(offset_of_table_directory_structure > block_size - size_of_table_directory_structure)
	{
		free(the_block);
		return printf("Offset of table directory structure is out of bounds.\n");
	}

	memmove(&number_of_rows_from_table_directory, &the_block[offset_of_table_directory_structure+2],2);
	if(vdebug)
		printf("Number of rows 2: %d\n",number_of_rows_from_table_directory);

	//This is not a complete solution, but helps in some cases. More debugging and testing is needed!!!\n
	
	if(number_of_rows_from_table_directory != number_of_rows){
		if(vdebug)
			printf("\n\n>>>>>>>> WARNING WARNING WARNING >>>>>>>>\n\nNumber of rows from table directory structure\ndoes not match the number of rows from the\ndata header structure!\n\n<<<<<<<< WARNING WARNING WARNING <<<<<<<<\n\n");
		
		print_row=1;

		//This fixed number worked for me for some simple tables. This is not a complete solution
		offset_of_data_header_structure=100;
		// number of table directories
		memmove(&number_of_table_directories,&the_block[offset_of_data_header_structure+1],1);

		//This is not a complete solution, but works in some cases. More testing and debugging is needed!!!

		memmove(&number_of_table_directories,&the_block[offset_of_data_header_structure+1],1);

		if(vdebug)
			printf("Number of table directories: %d\n",number_of_table_directories);

		// Get the number of rows
		memmove(&number_of_rows,&the_block[offset_of_data_header_structure+2],2);
		if(vdebug)
			printf("Number of rows: %d\n",number_of_rows);

		// Get the start of the free space offset
		memmove(&freespace_offset_start,&the_block[offset_of_data_header_structure+6],2);
		if(vdebug)
			printf("Freespace offset start: %X\n",freespace_offset_start);

		// Get the end of the free space offset
		memmove(&freespace_offset_end,&the_block[offset_of_data_header_structure+8],2);
		if(vdebug)
			printf("Freespace offset end: %X\n",freespace_offset_end);

		offset_of_table_directory_structure = offset_of_data_header_structure + size_of_data_header_structure;
		if(offset_of_table_directory_structure > block_size - size_of_table_directory_structure)
		{
			free(the_block);
			return printf("Offset of table directory structure is out of bounds.\n");
		}

		memmove(&number_of_rows_from_table_directory, &the_block[offset_of_table_directory_structure+2],2);
		if(vdebug)
			printf("Number of rows 2: %d\n",number_of_rows_from_table_directory);
		
		if(number_of_rows_from_table_directory != number_of_rows)
			printf("I tried the recalculation with static header offsets, but it is still wrong: %d!\n", object_id);

	}//End of the recalcuation
	
	offset_of_row_directory = offset_of_table_directory_structure + size_of_table_directory_structure;
	if(offset_of_row_directory > block_size)
	{
		free(the_block);
		return printf("Offset of row directory is out of bounds.\n");
	}
	

	// For each additional table directory structure above 1
	// add 4 bytes
	
	
	offset_of_row_directory = offset_of_row_directory + number_of_table_directories*4 - 4;


	if(action == DUMPNOTVIAOFFSETS || action == SHOWDELETEDNOTVIAOFFSETS)
	{
		ttl = 0;
		while(1)
		{
			// 4 bytes for tail of block
			if(freespace_offset_end+offset_of_data_header_structure+ttl >= block_size-4)
				break;

			if(vdebug)
				printf("Block ID: %d, Offset: %X\n",block_number,freespace_offset_end+offset_of_data_header_structure+ttl);
			if(print_row) ret = ProcessRow(&the_block[freespace_offset_end+offset_of_data_header_structure+ttl],&hsize);
			ttl = ttl + ret + hsize;
			//printf("\n\n");
		}
		free(the_block);
		return 0;

	}

	while(count < number_of_rows)
	{

		g_indx = count;
		if((count * 2 + offset_of_row_directory) > block_size)
		{
			printf("Count is out of bounds!\n");
			free(the_block);
			return 0;
		}
		memmove(&row_offset,&the_block[offset_of_row_directory+count*2],2);
		g_row_offset = row_offset;

		// When a row is updated and the same space is not used
		// then the old offset is marked with SFFL (slot free flag)
		// either 0xFFFF or less than size

		if(row_offset == 0xFFFF)
			count ++;
		else if(row_offset < number_of_rows)
			count ++;
		else
		{
			if(row_offset + offset_of_data_header_structure < block_size)
			{
				if(vdebug)
				{
					printf("Offset: %.2X (REAL: %.2X)\n",row_offset+offset_of_data_header_structure,row_offset);
					printf("Row header: %.2X %d\n",the_block[row_offset+offset_of_data_header_structure], row_offset+offset_of_data_header_structure);
				}
				if(print_row) ProcessRow(&the_block[row_offset+offset_of_data_header_structure],&hsize);
				if(vdebug)
					printf("\n");
			}
			else
			{
				if(vdebug)
					printf("\n\n>>>>>>>> WARNING WARNING WARNING >>>>>>>>\n\nRow offset is out of bounds\n\n<<<<<<<< WARNING WARNING WARNING <<<<<<<<\n\n");
			}
			count ++;
		}
		g_last_offset = row_offset;

	}


	count = 0;




	free(the_block);


	return 0;
}

// ProcessRow returns the number of bytes of the row

int ProcessRow(unsigned char *row, unsigned int *hsize)
{
	unsigned int column_count = 0;
	unsigned int count = 0;
	unsigned int size_of_column = 0;
	unsigned int total = 0;
	unsigned int row_header_size = 3;
	unsigned int cnt = 0;
	unsigned int ret = 0;
	unsigned int rid = 0;
	unsigned char fl = 0;
	unsigned short curc = 0;
	unsigned short comc = 0;
	unsigned char pk[6]="";
	unsigned char nk[6]="";
	unsigned char hrid[6]="";
	unsigned char nrid[6]="";
	unsigned int nblock_id=0;

	if(vdebug)
	{
		printf("Row flags: %.2X\n",row[0]);
		printf("Lock status: %.2X\n",row[1]);
		printf("Columns: %.2X\n\n",row[2]);
	}




	fl = row[0];
	
	if(fl & ORAROWFL_K)
	{

		memmove(&curc,&row[3],2);
		memmove(&comc,&row[5],2);
		memmove(&pk,&row[7],6);
		memmove(&nk,&row[13],6);
		column_count = row[2];
		count = 0;
		*hsize = row_header_size = 19;
		if(vdebug)
		{
			printf("Cluster Key\n");
			printf("curc: %.4X\n",curc);
			printf("comc: %.4X\n",comc);
			printf("Previous Key: %.2X%.2X%.2X%.2X%.2X%.2X\n",pk[0],pk[1],pk[2],pk[3],pk[4],pk[5]);
			printf("Next Key: %.2X%.2X%.2X%.2X%.2X%.2X\n",nk[0],nk[1],nk[2],nk[3],nk[4],nk[5]);
		}
		ret = PrintColumns(row,row_header_size);
		return ret;
	}


	if((fl & ORAROWFL_H) && (fl & ORAROWFL_D) && (fl & ORAROWFL_F) && (fl & ORAROWFL_L) && !(fl & ORAROWFL_K) && !(fl & ORAROWFL_C) && !(fl & ORAROWFL_N) && !(fl & ORAROWFL_P))
	{

		//printf("HDFL: Block ID = %d, Row Offset = %d [%X], File offset = %d, Row Header = [%.2X %.2X %.2X]\n",block_number, g_row_offset,g_row_offset, block_number * block_size + g_row_offset + offset_of_data_header_structure, row[0],row[1],row[2]);

		// Sometimes in 10g HDFL are only 2 bytes ...
		// How do we determine this ???

		if(g_last_offset - g_row_offset==2 || row[2]==0x2C || row[2]==0x3C)
			return 2;


		*hsize = row_header_size = 3;
		if(vdebug)
			printf("HDFL\n");
		ret = PrintColumns(row,row_header_size);
		return ret;
	}


	// We have a full row
	if((fl & ORAROWFL_H) && (fl & ORAROWFL_F) && (fl & ORAROWFL_L) && !(fl & ORAROWFL_C) && !(fl & ORAROWFL_D))
	{
		*hsize = row_header_size = 3;
		if(vdebug)
			printf("Non-cluster...\n");
		ret = PrintColumns(row,row_header_size);
		return ret;
	}


	// We have a cluster member full row
	if((fl & ORAROWFL_H) && (fl & ORAROWFL_F) && (fl & ORAROWFL_L) && (fl & ORAROWFL_C))
	{
		*hsize = row_header_size = 4;
		if(vdebug)
			printf("Cluster member...\n");
		ret = PrintColumns(row,row_header_size);
		return ret;

	}

	// We have a full row
	if(!(fl & ORAROWFL_H) && (fl & ORAROWFL_F) && (fl & ORAROWFL_L) && (fl & ORAROWFL_C))
	{
		*hsize = row_header_size = 10;
		memmove(&hrid,&row[4],6);
		if(vdebug)
		{
			printf("cluster member missing head piece...\n");
			printf("HRID: %.2X%.2X%.2X%.2X%.2X%.2X\n",hrid[0],hrid[1],hrid[2],hrid[3],hrid[4],hrid[5]);
		}
		ret = PrintColumns(row,row_header_size);
		return ret;
	}


	if(!(fl & ORAROWFL_H) && (fl & ORAROWFL_F) && (fl & ORAROWFL_L) && !(fl & ORAROWFL_C))
	{
		*hsize = row_header_size = 10;
		memmove(&hrid,&row[4],6);
		if(vdebug)
		{
			printf("Missing head piece...\n");
			printf("HRID: %.2X%.2X%.2X%.2X%.2X%.2X\n",hrid[0],hrid[1],hrid[2],hrid[3],hrid[4],hrid[5]);
		}
		ret = PrintColumns(row,row_header_size);
		return ret;
	}



	// We have a head piece only
	if((fl & ORAROWFL_H) && !(fl & ORAROWFL_F) && !(fl & ORAROWFL_L) && !(fl & ORAROWFL_C))
	{
		*hsize = row_header_size = 9;
		memmove(&nrid,&row[3],6);
		if(vdebug)
		{
			printf("Head piece only ...\n");
			printf("NRID: %.2X%.2X%.2X%.2X%.2X%.2X\n",nrid[0],nrid[1],nrid[2],nrid[3],nrid[4],nrid[5]);
		}
		ret = PrintColumns(row,row_header_size);
		return ret;
	}


	// We have a head piece only and cluster member
	if((fl & ORAROWFL_H) && !(fl & ORAROWFL_F) && !(fl & ORAROWFL_L) && (fl & ORAROWFL_C))
	{
		*hsize = row_header_size = 10;
		memmove(&nrid,&row[4],6);
		if(vdebug)
		{
			printf("Cluster member, head piece only ...\n");
			printf("NRID: %.2X%.2X%.2X%.2X%.2X%.2X\n",nrid[0],nrid[1],nrid[2],nrid[3],nrid[4],nrid[5]);
		}
		ret = PrintColumns(row,row_header_size);
		return ret;
	}




	//  Last column continues in next piece
	if((fl & ORAROWFL_N) && !(fl & ORAROWFL_C))
	{
		*hsize = row_header_size = 9;
		memmove(&nrid,&row[3],6);
		nblock_id = nrid[2]*256 + nrid[3];
		if(vdebug)
		{
			printf("Last col continues in next piece ...\n");
			printf("NRID: %.2X%.2X%.2X%.2X%.2X%.2X\n",nrid[0],nrid[1],nrid[2],nrid[3],nrid[4],nrid[5]);
			printf("Block ID that contains the next piece: %d\n",nblock_id);
		}
		ret = PrintColumns(row,row_header_size);
		return ret;
	}

	// Last data piece 
	if((fl & ORAROWFL_L) && !(fl & ORAROWFL_N) && !(fl & ORAROWFL_P) && !(fl & ORAROWFL_D) && !(fl & ORAROWFL_F) && !(fl & ORAROWFL_H) && !(fl & ORAROWFL_C) && !(fl & ORAROWFL_K))
	{
		*hsize = row_header_size = 3;
		if(vdebug)
			printf("Last data piece \n");
		ret = PrintColumns(row,row_header_size);
		return ret;
	}




	// Last data piece and First column continues from previous piece
	if((fl & ORAROWFL_P) && (fl & ORAROWFL_L) && !(fl & ORAROWFL_C))
	{
		*hsize = row_header_size = 3;
		if(vdebug)
			printf("Last data piece and First column continues from previous piece\n");
		ret = PrintColumns(row,row_header_size);
		return ret;
	}


	// Head piece of row & First data piece
	if((fl & ORAROWFL_H) && (fl & ORAROWFL_F) && !(fl & ORAROWFL_C))
	{
		*hsize = row_header_size = 9;
		memmove(&nrid,&row[3],6);
		nblock_id = nrid[2]*256 + nrid[3];
		rid = nrid[4]*256 + nrid[5];
		if(vdebug)
		{
			printf("Head piece of row & First data piece\n");
			printf("NRID: %.2X%.2X%.2X%.2X%.2X%.2X\n",nrid[0],nrid[1],nrid[2],nrid[3],nrid[4],nrid[5]);
			printf("Block ID that contains the next piece: %d, row %d\n",nblock_id,rid);
		}
		ret = PrintColumns(row,row_header_size);
		return ret;
	}

	if((fl & ORAROWFL_D) && (fl & ORAROWFL_L) && !(fl & ORAROWFL_C))
	{
		*hsize = row_header_size = 3;
		if(vdebug)
			printf("Deleted and Last Piece\n");
		ret = PrintColumns(row,row_header_size);
		return ret;
	}

	if((fl & ORAROWFL_D) && !(fl & ORAROWFL_N) && !(fl & ORAROWFL_P) && !(fl & ORAROWFL_L) && !(fl & ORAROWFL_F) && !(fl & ORAROWFL_H) && !(fl & ORAROWFL_C) && !(fl & ORAROWFL_K))
	{

		// If the only flag set is D then header is only two bytes...or so it seems
		*hsize = row_header_size = 2;
		if(vdebug)
		printf("Deleted\n"); 
		return 2;
	}


	if((fl & ORAROWFL_F) && !(fl & ORAROWFL_N) && !(fl & ORAROWFL_P) && !(fl & ORAROWFL_L) && !(fl & ORAROWFL_D) && !(fl & ORAROWFL_H) && !(fl & ORAROWFL_C) && !(fl & ORAROWFL_K))
	{
		*hsize = row_header_size = 15;
		memmove(&hrid,&row[3],6);
		memmove(&nrid,&row[9],6);
		if(vdebug)
		{
			printf("First data piece\n");
			printf("HRID: %.2X%.2X%.2X%.2X%.2X%.2X\n",hrid[0],hrid[1],hrid[2],hrid[3],hrid[4],hrid[5]);
			printf("NRID: %.2X%.2X%.2X%.2X%.2X%.2X\n",nrid[0],nrid[1],nrid[2],nrid[3],nrid[4],nrid[5]);
		}
		ret = PrintColumns(row,row_header_size);
		return ret;
	}






	if(!fl)
	{
		*hsize = row_header_size = 3;
		return ret;
	}





	//getch();
	return 3;


}


int PrintColumns(unsigned char *row, unsigned int row_header_size)
{
	unsigned int column_count = 0;
	unsigned count = 0;
	unsigned int total = 0;
	unsigned int extra = 0;
	unsigned int size_of_column = 0;
	unsigned int cnt = 0;
	unsigned char *buf=NULL;

	//printf("Block ID = %d, Row Offset = %d [%X], File offset = %d, Row Header = [%.2X %.2X %.2X]\n",block_number, g_row_offset,g_row_offset, block_number * block_size + g_row_offset + offset_of_data_header_structure, row[0],row[1],row[2]);

		
	if(action == SHOWDELETED || action == SHOWDELETEDNOTVIAOFFSETS)
	{
		if(row[0] & ORAROWFL_D)
		{
			printf("\n+---------------------------------------------------------\n");
			if(verbose)
				printf("Block ID = %d, Row Offset = %d [%X], File offset = %d, Row Header = [%.2X %.2X %.2X]\n",block_number, g_row_offset,g_row_offset, block_number * block_size + g_row_offset + offset_of_data_header_structure, row[0],row[1],row[2]);

		}
	}
	else
	{
		printf("\n----------------------------------------------------------\n");
		if(verbose)
			printf("Block ID = %d, Row Offset = %d [%X], File offset = %d, Row Header = [%.2X %.2X %.2X]\n",block_number, g_row_offset,g_row_offset, block_number * block_size + g_row_offset + offset_of_data_header_structure, row[0],row[1],row[2]);

	}

	

	// 3rd byte of row header contains column count
	column_count = row[2];


	


	// For each column extract data
	while(count < column_count)
	{
next:

		size_of_column = row[row_header_size+total+extra];
		if(size_of_column == 0xFF)
		{
			if(col_template_present)
			{
				if(action == SHOWDELETED || action == SHOWDELETEDNOTVIAOFFSETS)
				{
					if(row[0] & ORAROWFL_D)
					{
						DisplayColumn(count,"",0);
						//printf("NULL\n");
					}
				}
				else
				{
					DisplayColumn(count,"",0);
				}
			}
			else
			{
				if(action == SHOWDELETED || action == SHOWDELETEDNOTVIAOFFSETS)
				{
					if(row[0] & ORAROWFL_D)
					{
						printf("1: FF\n");
					}
				}
				else
				{
					printf("1: FF\n");
				}
			}
			total ++;
			count++;
			if(count == column_count)
				break;
			goto next;
		}
		if(size_of_column == 0xFE)
		{
			total++;
			memmove(&size_of_column,&row[row_header_size+total+extra],2);
			total ++;
			goto CN;
			/*
			total ++;
			cnt = 0;
			if(action == SHOWDELETED || action == SHOWDELETEDNOTVIAOFFSETS)
			{
				if(row[0] & ORAROWFL_D)
				{
					printf("%d: ",size_of_column);
					while(cnt < size_of_column)
					{
						printf("%.2X ",row[row_header_size+total+extra]);
						total ++;
						cnt ++;
					}
					printf("\n");
				}
			}
			else
			{
				printf("%d: ",size_of_column);
				while(cnt < size_of_column)
				{
					printf("%.2X ",row[row_header_size+total+extra]);
					total ++;
					cnt ++;
				}
				printf("\n");
			}*/
		}
		else
		{


CN:
			total ++;	
			cnt = 0;

			if(col_template_present)
			{

				buf = (unsigned char *)malloc(size_of_column+1);
				if(!buf)
				{
					printf("malloc failure!\n");
					return 0;
				}
				memset(buf,0,size_of_column+1);

				while(cnt < size_of_column)
				{
					buf[cnt]= row[row_header_size+total+extra];
					extra++;
					cnt ++;
				}

				if(action == SHOWDELETED || action == SHOWDELETEDNOTVIAOFFSETS)
				{
					if(row[0] & ORAROWFL_D)
					{
						if(!DisplayColumn(count,buf,size_of_column))
						{
							// if this failed then we need to reset extra
							extra = extra - cnt;
							free(buf);
							buf = NULL;
							goto NOCOLINFO1;
						}
						else
						{
							free(buf);
							buf = NULL;
						}
					}
				}
				else
				{
					if(!DisplayColumn(count,buf,size_of_column))
					{
						// if this failed then we need to reset extra
						extra = extra - cnt;
						free(buf);
						buf = NULL;
						goto NOCOLINFO1;
					}
					else
					{
						free(buf);
						buf = NULL;
					}

				}
			}
			else
			{
NOCOLINFO1:
				cnt = 0;

				if(action == SHOWDELETED || action == SHOWDELETEDNOTVIAOFFSETS)
				{
					if(row[0] & ORAROWFL_D)
					{
						printf("%d: ",size_of_column);
					}
				}
				else
				{
					printf("%d: ",size_of_column);
				}
				while(cnt < size_of_column)
				{	
					if(action == SHOWDELETED || action == SHOWDELETEDNOTVIAOFFSETS)
					{
						if(row[0] & ORAROWFL_D)
						{
							printf("%.2X ",row[row_header_size+total+extra]);
						}
					}
					else
					{
						printf("%.2X ",row[row_header_size+total+extra]);
					}
					total ++;
					cnt ++;
				}
				if(action == SHOWDELETED || action == SHOWDELETEDNOTVIAOFFSETS)
				{
					if(row[0] & ORAROWFL_D)
					{
						printf("\n");
					}
				}
				else
				{
					printf("\n");
				}
			}
			

		}
		count ++;
	}

	return total+extra;
}

int DisplayColumn(int column_number, unsigned char *buf, unsigned int buf_len)
{
	FILE *fd = NULL;
	int count = -1;
	unsigned char buffer[260]="";
	char *res = NULL;
	unsigned int c = 0;
	unsigned int total = 0;
	unsigned int mp = 0;
	unsigned int yyyy;


	// buf_len should never be more than 0xFFFF 
	// but if it is return

	if(buf_len > 0xFFFF)
	{
		if(vdebug)
			printf("Input too large!\n");
		return 0;
	}

	fd = fopen(column_template_file,"r");
	if(!fd)
	{
		if(vdebug)
			printf("Failed to open column template file.\n");
		return 0;
	}

	// cycle through file to get right column
	while(count < column_number)
	{
		res = fgets(buffer,256,fd);
		count ++;
	}

	fclose(fd);

	// if fgets returns NULL it means we've passed the column count
	// and there's no info in the column template for the column
	// number so retirn 0 to dump the hex 

	if(res == NULL)
		return 0;

	// remove newline if present
	if(buffer[strlen(buffer)-1]==0x0A)
		buffer[strlen(buffer)-1]=0;

	if(strcmp(buffer,"NUMBER")==0)
	{
		if(buf[0]==0x80)
		{
			printf("0\n");
		}
		else
		{
			buf[0]=buf[0]-0xC0;

			c = 1;
			mp = 1;
			while(c < buf[0])
			{

				mp = mp * 100;
				c ++;
			}
			c = 1;
			total = 0;
			while(c < buf_len)
			{

				total = total + ((buf[c]-1) * mp);
				mp = mp / 100;
				c++;	
			}
			printf("%d%c",total,sep[0]);
		}

	}
	else if(strcmp(buffer,"VARCHAR2")==0)
	{
		c = 0;
		while(c < buf_len)
		{
			printf("%c",buf[c]);
			c++;
		}
		printf("%c",sep[0]);
	}
	else if(strcmp(buffer,"DATE")==0)
	{
		yyyy = (buf[0] - 0x64) * 100 + (buf[1] - 0x64);
		printf("%.4d/%.2d/%.2d %.2d:%.2d:%.2d%c",yyyy,buf[2],buf[3],buf[4]-1,buf[5]-1,buf[6]-1,sep[0]);
	}
	else if(strcmp(buffer,"CHAR")==0)
	{
		printf("CHAR\n");
	}
	else if(strcmp(buffer,"UNKNOWN")==0)
	{
		return 0;
	}
	else if(strcmp(buffer,"NOPRINT")==0)
	{
		return 1;
	}
	else
	{
		return 0;
	}

	return 1;
}

